#
# Cookbook Name:: elasticSearch
# Recipe:: default
#
# Copyright 2012, inConcert
#
# All rights reserved - Do Not Redistribute
#


#
# make helper methods available inside templates.
#
#class Erubis::Context
#	include Redis::Helpers
#end

include_recipe "runit"

if node.inconcert.elasticsearch_nodes.size == 0 then
	raise "Debe ingresar al menos un nodo para elasticsearch"
end 

esNode = false
esDialerNode = false
node.elasticsearch.number_of_shards = "1"
if node.inconcert.elasticsearch_nodes.size == 1 then
	node.elasticsearch.number_of_replicas = "0"
else
	if node.inconcert.elasticsearch_nodes.size == 2 then
		node.elasticsearch.number_of_replicas = "1"
	else
		node.elasticsearch.number_of_replicas = "2"
	end
end

node.elasticsearch_dialer.number_of_shards = "1"
if node.inconcert.elasticsearch_dialer_nodes.size == 1 then
	node.elasticsearch_dialer.number_of_replicas = "0"
else
	if node.inconcert.elasticsearch_dialer_nodes.size == 2 then
		node.elasticsearch_dialer.number_of_replicas = "1"
	else
		node.elasticsearch_dialer.number_of_replicas = "2"
	end
end

node.inconcert.elasticsearch_nodes.map do |n|
	if n['id'].is_a? String then
		if n['id'] == node.hostname then
			esNode = true
			if n['path_to_data'].size > 0 then
				node.elasticsearch.es_path_to_data = n['path_to_data']
			else
				raise "Debe seleccion el path para la data de ElasticSearch"
			end
			if n['path_to_log'].is_a? String then
				node.elasticsearch.es_path_to_log = n['path_to_log']
			else
				raise "Debe seleccion el path para los logs de ElasticSearch"
			end
			if n['private_ip'].is_a? String then
				node.elasticsearch.private_ip = n['private_ip']
			else	
				raise "Debe seleccion la IP privada del nodo."
			end










		end
	end
end

if node["platform"] == "ubuntu" then
	node.inconcert.elasticsearch_dialer_nodes.map do |n|
		if n['id'].is_a? String then
			if n['id'] == node.hostname then
				esDialerNode = true
				if node.inconcert.elasticsearch_dialer_nodes.size == 2 then
					raise "La cantidad de nodos para ES Dialer debe ser 1 o mayor a 2."
				end
				if n['path_to_data'].size > 0 then
					node.elasticsearch_dialer.es_path_to_data = n['path_to_data']
				else
					raise "Debe seleccion el path para la data de ElasticSearch Dialer"
				end
				if n['path_to_log'].is_a? String then
					node.elasticsearch_dialer.es_path_to_log = n['path_to_log']
				else
					raise "Debe seleccion el path para los logs de ElasticSearch Dialer"
				end
				if n['private_ip'].is_a? String then
					node.elasticsearch_dialer.private_ip = n['private_ip']
				else	
					raise "Debe seleccion la IP privada del nodo."
				end
				node.elasticsearch_dialer.number_of_shards = "1"
				if node.inconcert.elasticsearch_dialer_nodes.size == 1 then
					node.elasticsearch_dialer.number_of_replicas = "0"
				else
					node.elasticsearch_dialer.number_of_replicas = "2"
				end
			end
		end
	end
end

if esNode or esDialerNode then
	#Elimino version anterior 
	bash "[ELASTIC-SEARCH] Delete old ElasticSearch" do
	  user    "root"
	  cwd     "/tmp"
	  code  <<-EOH
		rm -rf /usr/share/elasticsearch/bin/*
		rm -rf /usr/share/elasticsearch/config/*
		rm -rf /usr/share/elasticsearch/lib/*
		rm -rf /usr/share/elasticsearch/plugins/*
	  EOH
	  not_if "ls /usr/share/elasticsearch/.bootstrapped_es-#{node.elasticsearch.version}"
	end
	
	# Descargo e Instalo elasticsearch.
	bash "[ELASTIC-SEARCH] Download elasticsearch-#{node.elasticsearch.version}.tar.gz" do
	  user    "root"
	  cwd     "/tmp"
	  code  <<-EOH
		wget -q http://#{node.inconcert.sources.server}/repo/elasticsearch-#{node.elasticsearch.version}.tar.gz -O /tmp/elasticsearch-#{node.elasticsearch.version}.tar.gz
	  EOH
	  not_if "ls /usr/share/elasticsearch/.bootstrapped_es-#{node.elasticsearch.version}"
	end
	
	bash "[ELASTIC-SEARCH] Install elasticsearch-#{node.elasticsearch.version} from gz file" do
	  user    "root"
	  cwd     "/tmp"
	  code  <<-EOH
		tar -xvzf elasticsearch-#{node.elasticsearch.version}.tar.gz
		mkdir /usr/share/elasticsearch
		cp -r elasticsearch-#{node.elasticsearch.version}/* /usr/share/elasticsearch/
		rm -f elasticsearch-#{node.elasticsearch.version}.tar.gz
	  EOH
	  not_if "ls /usr/share/elasticsearch/.bootstrapped_es-#{node.elasticsearch.version}"
	end
	
	bash "[ELASTIC-SEARCH] add user elasticsearch" do
	  cwd "/usr/share/elasticsearch"
	  code <<-EOC
		adduser elasticsearch --home /usr/share/elasticsearch --group --system --quiet || exit 1
		chown -R elasticsearch:elasticsearch /usr/share/elasticsearch
		chmod -R 775  /usr/share/elasticsearch
	  EOC
	end
end

# Elastic Search Interacciones ==================================================================
if esNode then
	

	node.elasticsearch.es_path_to_data.each do |d| 
	  directory d do
		recursive true
		owner  "elasticsearch"
		group  "elasticsearch"
		mode   "0700"
		action :create
	  end
	end

	directory "#{node.elasticsearch.es_path_to_log}" do
	  recursive true
	  owner  "elasticsearch"
	  group  "elasticsearch"
	  mode   "0700"
	  action :create
	end
	
	node.elasticsearch.es_path_to_data.each do |d| 
		bash "[ELASTIC-SEARCH] permission for data directory" do
			cwd "#{d}"
			code <<-EOC
				chown -R elasticsearch:elasticsearch #{d}
				chmod -R 775  #{d}
			EOC
		end
	end
	
	bash "[ELASTIC-SEARCH] permission for log directory" do
	  cwd "#{node.elasticsearch.es_path_to_log}"
	  code <<-EOC
		chown -R elasticsearch:elasticsearch #{node.elasticsearch.es_path_to_log}
		chmod -R 775  #{node.elasticsearch.es_path_to_log}
	  EOC
	end
	
	node.elasticsearch.es_path_to_data.each do |d| 
		bash "[ELASTIC-SEARCH] Delete Old data on: #{d}/#{node.inconcert.cluster_id}/" do
		  cwd "#{d}"
		  code <<-EOC
			rm -rf #{d}/#{node.inconcert.cluster_id}/*
		  EOC
		  not_if "ls /usr/share/elasticsearch/.bootstrapped_es-#{node.elasticsearch.version}"
		end
	end
	







	cookbook_file "/usr/share/elasticsearch/bin/elasticsearch" do
	  source "elasticsearch"
	  owner   "elasticsearch"
	  group   "elasticsearch"
	  mode    "0777"
	end
	
	cookbook_file "/usr/share/elasticsearch/config/jvm.options" do
	  source "jvm.options"
	  owner   "elasticsearch"
	  group   "elasticsearch"
	  mode    "0644"
	end
	
	if node.inconcert.elasticsearch_nodes.size == 1 then
		template "/usr/share/elasticsearch/config/elasticsearch.yml" do 
		  source "elasticsearch.yml-single_node.erb"
		  owner  "elasticsearch"
		  group  "elasticsearch"
		  mode   "0644"
		end
	else
		if node.inconcert.elasticsearch_nodes.size == 2 then
			if node.inconcert.elasticsearch_ip == node.elasticsearch.private_ip then
				template "/usr/share/elasticsearch/config/elasticsearch.yml" do 
				  source "elasticsearch.yml-two_nodes_master.erb"
				  owner  "elasticsearch"
				  group  "elasticsearch"
				  mode   "0644"
				end
			else
				template "/usr/share/elasticsearch/config/elasticsearch.yml" do 
				  source "elasticsearch.yml-two_nodes_slave.erb"
				  owner  "elasticsearch"
				  group  "elasticsearch"
				  mode   "0644"
				end
			end
		else
			template "/usr/share/elasticsearch/config/elasticsearch.yml" do 
			  source "elasticsearch.yml-cluster.erb"
			  owner  "elasticsearch"
			  group  "elasticsearch"
			  mode   "0644"
			end
		end
	end
	
	dir_service="/etc/inconcert/sv/elasticsearch"
	if not Dir.exist?(dir_service) then
		bash "[ELASTIC-SEARCH] Create Elasticsearch service directory" do
		  user    "root"
		  cwd     "/root"
		  code  <<-EOH
			mkdir -p /etc/inconcert/sv/elasticsearch
		  EOH
		end
	end
	
	cookbook_file "/etc/inconcert/sv/elasticsearch/run" do
	  source "run"
	  owner   "root"
	  group   "root"
	  mode    "0777"
	end
	
	bash "[ELASTIC-SEARCH] Create Elasticsearch service" do
	  user    "root"
	  cwd     "/root"
	  code  <<-EOH
		ln -s /etc/inconcert/sv/elasticsearch /etc/service/elasticsearch
		/usr/sbin/update-service --add /etc/inconcert/sv/elasticsearch
	  EOH
	end









end

# Elastic Search Dialer ==================================================================
if esDialerNode then









	

	if node["platform"] == "ubuntu" then
		bash "[ELASTIC-SEARCH-DIALER] Create Elasticsearch Config folder" do
		  user    "root"
		  cwd     "/root"
		  code  <<-EOH
			mkdir -p /usr/share/elasticsearch/config_dialer
			cp -r /usr/share/elasticsearch/config/* /usr/share/elasticsearch/config_dialer/
		  EOH
		end
	
	
		cookbook_file "/usr/share/elasticsearch/config_dialer/jvm.options" do
		  source "jvm.options"
		  owner   "elasticsearch"
		  group   "elasticsearch"
		  mode    "0644"
		end
		
		if node.inconcert.elasticsearch_dialer_nodes.size == 1 then
			template "/usr/share/elasticsearch/config_dialer/elasticsearch.yml" do 
			  source "elasticsearch.yml-single_node_dialer.erb"
			  owner  "elasticsearch"
			  group  "elasticsearch"
			  mode   "0644"
			end
		else
			template "/usr/share/elasticsearch/config_dialer/elasticsearch.yml" do 
			  source "elasticsearch.yml-cluster_dialer.erb"
			  owner  "elasticsearch"
			  group  "elasticsearch"
			  mode   "0644"
			end
		end
		
		node.elasticsearch_dialer.es_path_to_data.each do |d| 
		  directory d do
			recursive true
			owner  "elasticsearch"
			group  "elasticsearch"
			mode   "0700"
			action :create
		  end
		end

		directory "#{node.elasticsearch_dialer.es_path_to_log}" do
		  recursive true
		  owner  "elasticsearch"
		  group  "elasticsearch"
		  mode   "0700"
		  action :create
		end
		
		node.elasticsearch_dialer.es_path_to_data.each do |d| 
			bash "[ELASTIC-SEARCH-DIALER] permission for data directory" do
				cwd "#{d}"
				code <<-EOC
					chown -R elasticsearch:elasticsearch #{d}
					chmod -R 775  #{d}
				EOC
			end
		end
		
		bash "[ELASTIC-SEARCH-DIALER] permission for log directory" do
		  cwd "#{node.elasticsearch_dialer.es_path_to_log}"
		  code <<-EOC
			chown -R elasticsearch:elasticsearch #{node.elasticsearch_dialer.es_path_to_log}
			chmod -R 775  #{node.elasticsearch_dialer.es_path_to_log}
		  EOC
		end
		
		
		dir_service="/etc/inconcert/sv/elasticsearch_dialer"
		if not Dir.exist?(dir_service) then
			bash "[ELASTIC-SEARCH-DIALER] Create Elasticsearch service directory" do
			  user    "root"
			  cwd     "/root"
			  code  <<-EOH
				mkdir -p /etc/inconcert/sv/elasticsearch_dialer
			  EOH
			end
		end
		
		cookbook_file "/etc/inconcert/sv/elasticsearch_dialer/run" do
		  source "run_dialer"
		  owner   "root"
		  group   "root"
		  mode    "0777"
		end
		
		bash "[ELASTIC-SEARCH-DIALER] Create Elasticsearch Dialer service" do
		  user    "root"
		  cwd     "/root"
		  code  <<-EOH
			ln -s /etc/inconcert/sv/elasticsearch_dialer /etc/service/elasticsearch_dialer
			/usr/sbin/update-service --add /etc/inconcert/sv/elasticsearch_dialer
		  EOH
		end
			


















		bash "[ELASTIC-SEARCH-DIALER] Set permission to user elasticsearch" do
		  cwd "/usr/share/elasticsearch"
		  code <<-EOC
			chown -R elasticsearch:elasticsearch /usr/share/elasticsearch
			chmod -R 775  /usr/share/elasticsearch
		  EOC
		end
	end
end 

	
bash "[ELASTIC-SEARCH] Configure inConcert SHARDS and REPLICAS" do
  user "root"
  code <<-EOC
	set -e
	sed -i -e  "s/NUMBER_OF_SHARDS=.*/NUMBER_OF_SHARDS=#{node.elasticsearch.number_of_shards}/" /etc/inconcert/inconcert.conf
	sed -i -e  "s/NUMBER_OF_REPLICAS=.*/NUMBER_OF_REPLICAS=#{node.elasticsearch.number_of_replicas}/" /etc/inconcert/inconcert.conf
  EOC
  only_if "ls /etc/inconcert/inconcert.conf"
end

bash "[ELASTIC-SEARCH] Configure ES port" do
  user "root"
  code <<-EOC
	set -e
	sed -i -e  "s/ELASTICSEARCH_PORT=.*/ELASTICSEARCH_PORT=#{node.inconcert.elasticsearch_port}/" /etc/inconcert/inconcert.conf
  EOC
  only_if "ls /etc/inconcert/inconcert.conf"
end


bash "[ELASTIC-SEARCH-DIALER] Configure inConcert SHARDS and REPLICAS" do
  user "root"
  code <<-EOC
	set -e
	sed -i -e  "s/NUMBER_OF_SHARDS_DIALER=.*/NUMBER_OF_SHARDS_DIALER=#{node.elasticsearch_dialer.number_of_shards}/" /etc/inconcert/inconcert.conf
	sed -i -e  "s/NUMBER_OF_REPLICAS_DIALER=.*/NUMBER_OF_REPLICAS_DIALER=#{node.elasticsearch_dialer.number_of_replicas}/" /etc/inconcert/inconcert.conf
  EOC
  only_if "ls /etc/inconcert/inconcert.conf"
end
bash "[ELASTIC-SEARCH-DIALER] Configure ES Dialer port" do
  user "root"
  code <<-EOC
	set -e
	sed -i -e  "s/ELASTICSEARCH_DIALER_PORT=.*/ELASTICSEARCH_DIALER_PORT=#{node.inconcert.elasticsearch_dialer_port}/" /etc/inconcert/inconcert.conf
  EOC
  only_if "ls /etc/inconcert/inconcert.conf"
end

if esNode or esDialerNode then
	bash "[ELASTIC-SEARCH] Tocuh 'init elasticSearch'" do
	  cwd "/usr/share/elasticsearch"
	  code <<-EOC
		touch .bootstrapped_es-#{node.elasticsearch.version}
	  EOC
	end
end