
local args = require('pl.lapp') [[

i6 New User parameters generation:
  -H,--hotfixId  (string) 
]]

local json = require("cjson")
require "lua_cassandra"

local timeStamp = os.date("%Y-%m-%d %H:%m");

local cassandraIP = os.getenv("CASSANDRA_IP")
local cassandraPort = tonumber(os.getenv("CASSANDRA_PORT"))
lua_cassandra.seed(cassandraIP, cassandraPort)
local AgentKS = lua_cassandra:CassandraConnection("Agent")
local hotfixConfigFile = args.hotfixId .. ".conf"

local hostnameFile = "host.txt"
local f = io.open(hotfixConfigFile, "r")
local fh = io.open(hostnameFile,"r")

if f then
	local hotfixConfig = f:read("*all")
	local hostname = string.gsub(fh:read("*all"), "\n", "")
	hotfixConfigjson = json.decode(hotfixConfig)
	AgentKS:InsertColumn(args.hotfixId, "Hotfixes", "HotfixId", args.hotfixId)
	AgentKS:InsertColumn(args.hotfixId, "Hotfixes", "Description", hotfixConfigjson.description)
	AgentKS:InsertColumn(args.hotfixId, "Hotfixes", "timeStamp", timeStamp)
	AgentKS:InsertColumn(args.hotfixId, "Hotfixes", "hostName", hostname)
	print "Success insert cassandra row!"
else
	print "ERROR falta archivo de configuracion"
end

